/*
 * FastTextSearch for InterBase 1.4 from 15 Mar 2001
 *
 * Copyright (c) 1998-2001 by SoftLab MIL-TEC Ltd
 * Web    http://www.softcomplete.com
 * Email  support@softcomplete.com
 *
 * This script update FTSCore from v.1.3 to 1.4
 */

/* CHANGE database name, username and password in next line */
connect "database.gdb" user "SYSDBA" password "masterkey";

SET TERM ^ ;

ALTER PROCEDURE TS$SELECT_AND (
    OBJ_TYPE VARCHAR(32),
    WORDS VARCHAR(512),
    SOUNDEXFLAG INTEGER)
RETURNS (
    OBJ_ID INTEGER)
AS
declare variable Parser integer;
declare variable i integer;
declare variable qID integer;
declare variable qCount integer;
declare variable cnt integer;
declare variable word varchar(32);
declare variable wordnext varchar(32);
declare variable wsex integer;
declare variable o_type varchar(32);
begin
  qID=Gen_ID(UID,1);
  delete from TS$Query where id=:qID;
  OBJ_TYPE=StrUCase(OBJ_TYPE);
  Parser=Parser_CreateQuery();
  i=Parser_Add(Parser,WORDS);
  i=Parser_Reset(Parser);
  wordnext=Parser_Next(Parser);
  while ((wordnext is not null) and (wordnext <> '')) do begin
    word=wordnext;
    wsex=StrSoundEX(word);
    insert into TS$Query
      (ID,WORD,SND_CODE)
    values
      (:qID,:word,:wsex);
    wordnext=Parser_Next(Parser);
  end
  i=Parser_Free(Parser);
  qCount=0;
  select Count(*) from TS$Query where ID=:qID into :qCount;
  if (qCount > 0) then
    if (qCount =  1) then begin
        if (SoundExFlag = 1) then
          for 
            select distinct L.obj_id
              from TS$LINK L, TS$VOCAB V
              where V.SND_CODE = :wsex
                and L.word_id = V.id
            into :OBJ_ID
            do begin
              select obj_type from ts$obj where id=:obj_id into :o_type;
              if (o_type = obj_type) then suspend;
            end
        else
          for 
            select distinct L.obj_id
              from TS$LINK L, TS$VOCAB V
              where V.WORD >= :WORD
                and V.WORD starting with :WORD
                and L.word_id = V.id
            into :OBJ_ID
            do begin
              select obj_type from ts$obj where id=:obj_id into :o_type;
              if (o_type = obj_type) then suspend;
            end
    end else 
      for
        select OBJ_ID, Count(*)
          from ts$select_and1(:OBJ_TYPE,:qID,:SoundExFlag)
          group by OBJ_ID
        into :OBJ_ID, :cnt
        do if (cnt = qCount) then suspend;
  delete from TS$Query where id=:qID;  
end
^

ALTER PROCEDURE TS$SELECT_OR (
    OBJ_TYPE VARCHAR(32),
    WORDS VARCHAR(512),
    SOUNDEXFLAG INTEGER)
RETURNS (
    OBJ_ID INTEGER)
AS
declare variable Parser integer;
declare variable i integer;
declare variable qID integer;
declare variable wcnt integer;
declare variable wsex integer;
declare variable word varchar(32);
declare variable wordnext varchar(32);
declare variable o_type varchar(32);
begin
  qID=Gen_ID(UID,1);
  delete from TS$Query where id=:qID;
  OBJ_TYPE=StrUCase(OBJ_TYPE);
  Parser=Parser_CreateQuery();
  i=Parser_Add(Parser,WORDS);
  i=Parser_Reset(Parser);
  wcnt=0;
  wordnext=Parser_Next(Parser);
  while ((wordnext is not null) and (wordnext <> '')) do begin
    word=wordnext;
    wsex=StrSoundEX(word);
    insert into TS$Query
      (ID,WORD,SND_CODE)
    values
      (:qID,:word,:wsex);
    wcnt=wcnt+1;
    wordnext=Parser_Next(Parser);
  end
  i=Parser_Free(Parser);
  if (wcnt = 1) then
    if (SoundExFlag = 1) then
      for 
        select distinct L.obj_id
          from TS$LINK L, TS$VOCAB V
          where V.SND_CODE = :wsex
            and L.word_id = V.id
        into :OBJ_ID
        do begin
          select obj_type from ts$obj where id=:obj_id into :o_type;
          if (o_type = obj_type) then suspend;
        end
    else
      for 
        select distinct L.obj_id
          from TS$LINK L, TS$VOCAB V
          where V.WORD >= :WORD
            and V.WORD starting with :WORD
            and L.word_id = V.id
        into :OBJ_ID
        do begin
          select obj_type from ts$obj where id=:obj_id into :o_type;
          if (o_type = obj_type) then suspend;
        end
  else if (wcnt > 1) then
    if (SoundExFlag = 1) then
      for 
        select distinct L.obj_id
          from TS$LINK L, TS$VOCAB V, TS$QUERY Q
          where V.SND_CODE = Q.SND_CODE
            and Q.ID = :qID
            and L.word_id = V.id
        into :OBJ_ID
        do begin
          select obj_type from ts$obj where id=:obj_id into :o_type;
          if (o_type = obj_type) then suspend;
        end
    else
      for 
        select distinct L.obj_id
          from TS$LINK L, TS$VOCAB V, TS$QUERY Q
          where V.WORD >= Q.WORD
            and V.WORD starting with Q.WORD
            and Q.ID = :qID
            and L.word_id = V.id
        into :OBJ_ID
        do begin
          select obj_type from ts$obj where id=:obj_id into :o_type;
          if (o_type = obj_type) then suspend;
        end
  delete from TS$Query where id=:qID;
end
^

SET TERM ; ^

commit work;
